package it.gabrieleerba.nzuntachat.dfile;

import java.util.*;
import java.net.*; 
import java.io.*; 
/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  
 *  Copyright 2002 
 *
 * @author Gabriele Erba <nzunta@gabrile-erba.it>
 * @version 1.0
 *
 */
public class myserverfile extends Thread{
    Socket mysocket = null ;
    String PATH ;
    File myfile ;
     /**
     * 
     * costruttore del Thread
     * 
     * @param socket socket di connessione da gestire
     *
     * @param cond vettore condiviso con registrati i file condivisi
     */
    public myserverfile(Socket socket) { 
        this.mysocket = socket ;
    }
    public void run() {  
         try { 
            byte buffer[] = new byte[256] ;
            int n = 0 ;
             // Crea i canali per lo scambio dati
            BufferedOutputStream bu = new BufferedOutputStream(mysocket.getOutputStream()); 
            DataInputStream i = new DataInputStream(mysocket.getInputStream()) ;
            DataOutputStream out = new DataOutputStream(bu) ;
            // riceve il path del file da uploadare
            PATH = i.readUTF() ;
            // apre il file richiesto
            FileInputStream in = new FileInputStream(PATH) ;
            myfile= new File(PATH) ;
            // invia informazioni sul file
            out.writeLong(myfile.length()) ;
            out.writeUTF(myfile.getName()) ;
            // invia il file
            while ((n = in.read(buffer)) > -1) {
                out.write(buffer,0,n) ;
            }
            // chiude file e connesione
            out.close(); 
            mysocket.close();
        } 
        catch (UnknownHostException e){ 
            System.err.println("Host non trovato") ;
            e.printStackTrace();
        } 
        catch (IOException e){
            System.err.println("Problemi con il filesytem") ;
            e.printStackTrace();
        }
    }
}

